(* Global configurations *)
let debug_flag = ref false
let wait = ref 0.01
(* Utility functions referred globally *)
let warning s = prerr_endline ("*** " ^ Sys.argv.(0) ^ ": " ^ s ^ "\027[0K")

let debug s = if !debug_flag then prerr_endline ("+++ " ^ s ^ "\027[0K")

let outc = ref stdout
let set_outc o = flush (!outc); outc := o
let send s =
  (* debug ("Sending " ^ s); *)
  output_string (!outc) (s ^ "\n");
  flush (!outc)

let rec min_of f l =
  match l with
    [] -> failwith "min_of: empty"
  | [x] -> x, f x
  | x::l' ->
      let y, fy = min_of f l' in
      let fx = f x in
      if fx < fy then x, fx else y, fy
