{
 open Parser
 let lexeme lexbuf =
   let it = Lexing.lexeme lexbuf in
   (* if !Global.debug_flag then prerr_string it; *)
   it
}

let brank = [' ' '\t'] +
let int = ['0' - '9'] +
let id = '#' int
let row = ['.' '~' '#' '@'] +

rule start = parse
  brank { start lexbuf }
| 'N' { LETTER_N }
| 'W' { LETTER_W }
| 'E' { LETTER_E }
| 'S' { LETTER_S }
| 'P' { LETTER_P }
| 'D' { LETTER_D }
| 'X' { LETTER_X }
| 'Y' { LETTER_Y }
| int { INT (int_of_string (lexeme lexbuf)) }
| id { let it = lexeme lexbuf in
       ID (int_of_string (String.sub it 1 (String.length it - 1))) }
| row { ROW (lexeme lexbuf) }
| '\n' { EOL }
| eof { EOF }
